{$R+}
Program h;
{s pom. etoj prog. poluch. raspred. ier. v BIG5 i GB po 1-mu simvolu;
  sravnivaja s etalonn., mozhno dl`a fajla opr., v kakoj on kodir.
  Po 2-mu simvolu (s kl`uchom /a) eshcho naglqdnee, no eshcho naglqdnee
  ispol`z. anal_2b - tam vyv. grafik raspred. po param, a ne otdel`no
  po 1-mu i po 2-mu bajtu.
}
const b5:array[$80..$FF] of integer=(
{simv. i ier.: 10602 3692}
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0, 302,   4,   5, 419, 255, 324, 144, 123,  72, 215,  49, 175, 159,  56,  59,
 78,  73, 112, 102,  52,  57,  41,  60,  74,  51,  92,  59,  54,  36,  22,  14,
 63,  23,  38,  89,  21, 106,   6,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   2,   0,
  0,   0,   0,   0,   0,   0,   0,   1,   0,   3,   0,   0,   0,   0,   0,   0);

const gb2:array[$80..$FF] of integer=(
{simv. i ier.: 26567 12755}
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0, 382,  11, 780,   4,   4,   5,   6,  14,  13,  18,  12,  56,  13,   4,   8,
 79, 221, 219, 157, 181,1000, 452, 236, 195, 301, 254, 172, 208, 182, 220, 235,
210, 233,  71, 231, 287,  26, 316, 195, 211, 188, 393, 351, 196, 187, 337, 339,
652, 152, 452, 398, 431, 204, 380, 224,  19,   6,  31,   4,  14,   5,   2,   8,
  9,   4,  31,  14,  41,   6,  11,   8,   0,   4,   5,  13,   7,   5,  13,  17,
  8,   3,  25,  22,   5,   5,  17,   7,  29,   8,   6,   9,   8,  16,   3,   0);

const gb:array[$80..$FF] of integer=(
{simv. i ier.: 15983 6963}
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0, 433,   5, 299,   2,   0,   2,   1,   0,   0,   6,   1,   3,   0,   0,   2,
 63, 175, 168, 129, 105, 260, 144, 189, 141, 200, 144, 241, 389, 242,  82,  91,
 94, 238,  51,  47, 115,   6, 100,  77, 151, 128, 234, 145, 129,  79, 134, 304,
209,  95, 197, 261, 129,  28, 208, 192,   0,   1,   0,   2,   4,   1,   0,   6,
  0,   0,   1,   0,   8,   1,   1,   4,   3,   0,   4,   5,   2,   1,   7,   1,
  6,   0,   0,   2,  10,  13,   0,   3,   1,   0,   2,   2,   0,   2,   1,   1);

 var a2,b2,x2,ax,bx:real;
 var b,bb:file of byte;
 var c1,c2:byte; w:word; i,ii:longint; j:integer; po2:boolean;
 var a:array[$80..$FF] of word; aa:array[0..$FF] of word;
 var imya:string[80];
 var mnogo:boolean;
 const s:array[0..15] of char='0123456789ABCDEF';
 var n_simw,n_ier:longint; rb5,rgb:real;

Begin
 if (paramcount<>1) then begin
  writeln(' Obr.: prog infile .'); halt;
 end;
 {-----}
 imya:=paramstr(1);
 assign(b,imya); filemode:=0; reset(b);
 for j:=$80 to $FF do a[j]:=0; for j:=0 to $FF do aa[j]:=0;
 i:=0; ii:=0; mnogo:=false; repeat
  read(b,c1); inc(i); {if (i mod 1000)=0 then write(i,chr($0D));}
  if (c1>=$80) and not eof(b) then begin
   read(b,c2); inc(i); inc(ii); {if (i mod 1000)=0 then write(i,chr($0D));}
   if a[c1] <1000 then inc(a[c1]) else mnogo:=true;
   if aa[c2]<1000 then inc(aa[c2]) else mnogo:=true;
  end;
 until eof(b) or mnogo;
 close(b);
 n_simw:=i; n_ier:=ii;

(*
 writeln('     Vsego simv. i ier.: ',i,' ',ii);
 for j:=$80 to $FF do begin
  if j mod 16=0 then write(s[j shr 4],'0    ');
  write(a[j]:4,','); if (j mod 16)=15 then writeln;
 end;
*)
 ax:=0; bx:=0; a2:=0; b2:=0; x2:=0;
 for i:=$80 to $FF do begin
  ax:=ax+(1.0*b5[i])*a[i];
  bx:=bx+(1.0*gb[i])*a[i];
  a2:=a2+(1.0*b5[i])*b5[i];
  b2:=b2+(1.0*gb[i])*gb[i];
  x2:=x2+(1.0*a[i])*a[i];
 end;
 if x2>0 then rb5:=ax/sqrt(a2*x2) else rb5:=0;
 if x2>0 then rgb:=bx/sqrt(b2*x2) else rgb:=0;
 write(n_simw:5,' ',n_ier:5,n_ier/n_simw:8:4);
 write(' ',rb5:8:4,rgb:8:4);
 if (rb5>=0.7) and (rgb<0.4) then write(' - BIG5 - ')
 else if (rgb>=0.7) and (rb5<0.4) then write(' - GB   - ')
 else write(' - ???  - ');
 write(imya);
 writeln;

End.
